Bug 15131 - Give SCO separate control for AllowItemsOnHoldCheckout
Summary: Give SCO separate control for AllowItemsOnHoldCheckout
Status: CLOSED FIXED
Alias: None
Product: Koha
Classification: Unclassified
Component: Self checkout (show other bugs)
Version: unspecified
Hardware: All All
: P5 - low enhancement (vote)
Assignee: Tomás Cohen Arazi
QA Contact: Testopia
URL:
Keywords:
Depends on:
Blocks:
 
Reported: 2015-11-04 16:14 UTC by Kyle M Hall
Modified: 2017-06-14 22:16 UTC (History)
6 users (show)

See Also:
Change sponsored?: Sponsored
Patch complexity: Trivial patch
Text to go in the release notes:
Version(s) released in:


Attachments
Bug 15131: Instroduce AllowItemsOnHoldCheckoutSCO syspref (4.52 KB, patch)
2016-07-11 15:59 UTC, Tomás Cohen Arazi
Details | Diff | Splinter Review
Bug 15131: Make SCO use the new syspref. (1.45 KB, patch)
2016-07-11 16:00 UTC, Tomás Cohen Arazi
Details | Diff | Splinter Review
Bug 15131: Instroduce AllowItemsOnHoldCheckoutSCO syspref (4.56 KB, patch)
2016-09-19 15:52 UTC, PTFS Europe Sandboxes
Details | Diff | Splinter Review
Bug 15131: Make SCO use the new syspref. (1.51 KB, patch)
2016-09-19 15:52 UTC, PTFS Europe Sandboxes
Details | Diff | Splinter Review
Bug 15131: Instroduce AllowItemsOnHoldCheckoutSCO syspref (4.63 KB, patch)
2016-09-28 12:43 UTC, Jonathan Druart
Details | Diff | Splinter Review
Bug 15131: Make SCO use the new syspref. (1.58 KB, patch)
2016-09-28 12:43 UTC, Jonathan Druart
Details | Diff | Splinter Review
Bug 15131: Add AllowItemsOnHoldCheckoutSCO to UsageStats (2.22 KB, patch)
2016-09-28 12:43 UTC, Jonathan Druart
Details | Diff | Splinter Review

Note You need to log in before you can comment on or make changes to this bug.
Description Kyle M Hall 2015-11-04 16:14:28 UTC
Some libraries would like the ability to allow items on hold to be checked out to other patrons ( due to parents/kids with permission who pick up someone else's holds and other situations ) but not via the SCO module where librarians cannot verify the checkout should be allowed.

Idea:
1) Create new system preference AllowItemsOnHoldCheckoutSCO that will default to the current value of AllowItemsOnHoldCheckout
2) For the Koha SCO module, update all references to AllowItemsOnHoldCheckout to AllowItemsOnHoldCheckoutSCO
3) Add a notice to patrons attempting to check out items that are waiting for another patron when the checkout is denied
Comment 1 Tomás Cohen Arazi 2016-07-11 15:59:59 UTC
Created attachment 53273 [details] [review]
Bug 15131: Instroduce AllowItemsOnHoldCheckoutSCO syspref

This patch introduces a new syspref AllowItemsOnHoldCheckoutSCO, so the current
AllowItemsOnHoldCheckout syspref can be decoupled for the SCO module, giving
the library more flexibility.

During upgrade, it gets its value from the original AllowItemsOnHoldCheckout syspref.

Sponsored-by: NEKLS
Comment 2 Tomás Cohen Arazi 2016-07-11 16:00:02 UTC
Created attachment 53274 [details] [review]
Bug 15131: Make SCO use the new syspref.

This patch just makes SCO use the new syspref (AllowItemsOnHoldCheckoutSCO)
instead of the old one, thus making it configurable, separate from the
non-SCO syspref.

Sponsored-by: NEKLS
Comment 3 HB-NEKLS 2016-08-10 18:35:16 UTC
I'd like to test this, but could you add a test plan?

George
Comment 4 Tomás Cohen Arazi 2016-08-10 20:44:27 UTC
Sorry, I forgot to add the steps to test this patchset!

To test, you need to:
- Apply the patches on master
- Run:
  $ sudo koha-upgrade-schema kohadev
=> SUCCESS: Verify that AllowItemsOnHoldCheckoutSCO is set to the same value AllowItemsOnHoldCheckout was set
- Have an item that fills a hold
- Set AllowItemsOnHoldCheckoutSCO to "Don't allow"
- Try doing a checkout on the item, from the SCO interface
=> SUCCESS: You cannot.
- Set AllowItemsOnHoldCheckout to "Allow"
- Try doing a checkout on the item, from the SCO interface
=> SUCCESS: You cannot. The sysprefs are decoupled now.
- Set AllowItemsOnHoldCheckoutSCO to "Allow"
- Try doing a checkout on the item, from the SCO interface
=> SUCCESS: You can.
- Sign off :-D
Comment 5 PTFS Europe Sandboxes 2016-09-19 15:51:45 UTC
Patch tested with a sandbox, by George <george@nekls.org>
Comment 6 PTFS Europe Sandboxes 2016-09-19 15:52:13 UTC
Created attachment 55696 [details] [review]
Bug 15131: Instroduce AllowItemsOnHoldCheckoutSCO syspref

This patch introduces a new syspref AllowItemsOnHoldCheckoutSCO, so the current
AllowItemsOnHoldCheckout syspref can be decoupled for the SCO module, giving
the library more flexibility.

During upgrade, it gets its value from the original AllowItemsOnHoldCheckout syspref.

Sponsored-by: NEKLS

Signed-off-by: George <george@nekls.org>
Comment 7 PTFS Europe Sandboxes 2016-09-19 15:52:16 UTC
Created attachment 55697 [details] [review]
Bug 15131: Make SCO use the new syspref.

This patch just makes SCO use the new syspref (AllowItemsOnHoldCheckoutSCO)
instead of the old one, thus making it configurable, separate from the
non-SCO syspref.

Sponsored-by: NEKLS

Signed-off-by: George <george@nekls.org>
Comment 8 Jonathan Druart 2016-09-28 12:43:00 UTC
Created attachment 55883 [details] [review]
Bug 15131: Instroduce AllowItemsOnHoldCheckoutSCO syspref

This patch introduces a new syspref AllowItemsOnHoldCheckoutSCO, so the current
AllowItemsOnHoldCheckout syspref can be decoupled for the SCO module, giving
the library more flexibility.

During upgrade, it gets its value from the original AllowItemsOnHoldCheckout syspref.

Sponsored-by: NEKLS

Signed-off-by: George <george@nekls.org>

Signed-off-by: Jonathan Druart <jonathan.druart@bugs.koha-community.org>
Comment 9 Jonathan Druart 2016-09-28 12:43:04 UTC
Created attachment 55884 [details] [review]
Bug 15131: Make SCO use the new syspref.

This patch just makes SCO use the new syspref (AllowItemsOnHoldCheckoutSCO)
instead of the old one, thus making it configurable, separate from the
non-SCO syspref.

Sponsored-by: NEKLS

Signed-off-by: George <george@nekls.org>

Signed-off-by: Jonathan Druart <jonathan.druart@bugs.koha-community.org>
Comment 10 Jonathan Druart 2016-09-28 12:43:08 UTC
Created attachment 55885 [details] [review]
Bug 15131: Add AllowItemsOnHoldCheckoutSCO to UsageStats

Signed-off-by: Jonathan Druart <jonathan.druart@bugs.koha-community.org>
Comment 11 Jonathan Druart 2016-09-28 12:44:19 UTC
Note: There was something wrong in our doc:

"""
Important
This system preference relates only to SIP based self checkout, not Koha's web based self checkout.
"""

That was wrong but will be true after this patch.
Comment 12 Kyle M Hall 2016-10-21 17:29:14 UTC
Pushed to master for 16.11, thanks Tomas, Jonathan!